



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Java NIO之内存映射文件——MappedByteBuffer</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Java NIO之内存映射文件——MappedByteBuffer</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 01:47:48 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>大多数操作系统都可以利用虚拟内存实现将一个文件或者文件的一部分&quot;映射&quot;到内存中。然后，这个文件就可以当作是内存数组来访问，这比传统的文件要快得多。</p>
<p>内存映射文件的一个关键优势是操作系统负责真正的读写，即使你的程序在刚刚写入内存后就挂了，操作系统仍然会将内存中的数据写入文件系统。另外一个更突出的优势是共享内存，内存映射文件可以被多个进程同时访问，起到一种低时延共享内存的作用。</p>
<p>那么，如何将一个文件映射到内存呢？</p>
<ol><li>从文件中获得一个通道（channel）</li></ol>
<pre class="prettyprint linenums"><code>FileChannel channel = FileChannel.open(path,options);<br />
</code></pre>
<p>这里options指定映射模式，支持的模式有三种：</p>
<ul><li>FileChannel.MapMode.READ_ONLY：所产生的缓冲区是只读的。</li>
<li>FileChannel.MapMode.READ_WRITE：所产生的缓冲区是可写的,任何修改都会在某个时刻写回到文件中。<br /><br />
注意，其他映射同一个文件的程序可能不能立即看到这些修改，多个程序同时进行文件映射的确切行为是依赖<br /><br />
于操作系统的。</li>
<li>FileChannel.MapMode.PRIVATE：所产生的缓冲区是可写的，但是任何修改对该缓冲区来说都是私有的，不<br /><br />
会传播到文件中。</li></ul>
<ol><li>调用FileChannel的map方法</li></ol>
<pre class="prettyprint linenums"><code>MappedByteBuffer buffer = channel.map(FileChannel.MapMode.READ_ONLY,0,length);<br />
</code></pre>
<p>接下来通过计算一个40MB文件的CRC32校验和来比较传统的文件输入和内存映射文件的速度。</p>
<p>传统的文件输入包括：</p>
<ul><li>普通输入流（InputStream）</li>
<li>带缓冲的输入流（BufferedInputStream）</li>
<li>随机访问文件（RandomAccessFile）</li></ul>
<p>程序如下：</p>
<pre class="prettyprint linenums"><code>import java.io.*;<br />
import java.nio.MappedByteBuffer;<br />
import java.nio.channels.FileChannel;<br />
import java.nio.file.Files;<br />
import java.nio.file.Path;<br />
import java.nio.file.Paths;<br />
import java.util.zip.CRC32;

/**<br />
 * Created by lbd on 2017/1/11.<br />
 */<br />
public class MemoryMapTest {<br />
    public static long checksumInputStream(Path filename) throws IOException {  //普通输入流<br />
        try (InputStream in = Files.newInputStream(filename)) {<br />
            CRC32 crc = new CRC32();<br />
            int c;<br />
            while ((c = in.read()) != -1)<br />
                crc.update(c);<br />
            return crc.getValue();<br />
        }<br />
    }

    public static long checksumBufferedInputStream(Path filename) throws IOException {  //带缓冲的输入流<br />
        try (BufferedInputStream in = new BufferedInputStream(Files.newInputStream(filename))){<br />
            CRC32 crc = new CRC32();<br />
            int c;<br />
            while ((c = in.read()) != -1)<br />
                crc.update(c);<br />
            return crc.getValue();<br />
        }<br />
    }

    public static long checksumRandomAccessFile(Path filename) throws IOException {  //随机访问文件<br />
        try (RandomAccessFile file = new RandomAccessFile(filename.toFile(),&quot;r&quot;)){<br />
            CRC32 crc = new CRC32();<br />
            long length = file.length();

            for (long p = 0; p &lt; length; p++){<br />
                file.seek(p);<br />
                int c = file.readByte();<br />
                crc.update(c);<br />
            }<br />
            return crc.getValue();<br />
         }<br />
    }

    public static long checksumMappedFile(Path filename) throws IOException {  //内存映射文件<br />
        try (FileChannel channel = FileChannel.open(filename)){<br />
            CRC32 crc = new CRC32();<br />
            int length = (int)channel.size();<br />
            MappedByteBuffer buffer = channel.map(FileChannel.MapMode.READ_ONLY,0,length);

            for (int p = 0; p &lt; length; p++){<br />
                int c = buffer.get(p);<br />
                crc.update(c);<br />
            }<br />
            return crc.getValue();<br />
        }<br />
    }

    public static void main(String[] args) throws IOException {<br />
        System.out.println(&quot;Input Stream:&quot;);<br />
        long start = System.currentTimeMillis();<br />
        Path filename = Paths.get(args[0]);<br />
        long crcValue = checksumInputStream(filename);<br />
        long end = System.currentTimeMillis();<br />
        System.out.println(Long.toHexString(crcValue));<br />
        System.out.println((end - start) + &quot; milliseconds&quot;);<br />
        System.out.println();

        System.out.println(&quot;Buffered Input Stream:&quot;);<br />
        start = System.currentTimeMillis();<br />
        crcValue = checksumBufferedInputStream(filename);<br />
        end = System.currentTimeMillis();<br />
        System.out.println(Long.toHexString(crcValue));<br />
        System.out.println((end - start) + &quot; milliseconds&quot;);<br />
        System.out.println();

        System.out.println(&quot;Random Access File:&quot;);<br />
        start = System.currentTimeMillis();<br />
        crcValue = checksumRandomAccessFile(filename);<br />
        end = System.currentTimeMillis();<br />
        System.out.println(Long.toHexString(crcValue));<br />
        System.out.println((end - start) + &quot; milliseconds&quot;);<br />
        System.out.println();

        System.out.println(&quot;Mapped File:&quot;);<br />
        start = System.currentTimeMillis();<br />
        crcValue = checksumMappedFile(filename);<br />
        end = System.currentTimeMillis();<br />
        System.out.println(Long.toHexString(crcValue));<br />
        System.out.println((end - start) + &quot; milliseconds&quot;);<br />
    }<br />
}<br />
</code></pre>
<p>输出结果如下：</p>
<pre class="prettyprint linenums"><code>Input Stream:<br />
c644b1f1<br />
42317 milliseconds

Buffered Input Stream:<br />
c644b1f1<br />
329 milliseconds

Random Access File:<br />
c644b1f1<br />
57781 milliseconds

Mapped File:<br />
c644b1f1<br />
207 milliseconds<br />
</code></pre>
<p>可以明显看出，内存映射文件速度比普通输入流和随机访问文件快得多，比带缓冲的输入流稍微快一些。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qnwrgqr.html">Windows平台分布式架构实践 - 负载均衡（下）</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zk0kd8.html">Android6&period;0动态权限申请</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gdkje9.html">qq客服代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyg5ljq.html">通过SQL Server 2008数据库复制实现数据库同步备份</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyg362q.html">Angularjs学习笔记（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1ywdzq.html">Java学习笔记二&mdash;&mdash;标识符和关键字</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw427y8.html">css选择器中&colon;first-child与&colon;first-of-type的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8egk0k9.html">Hibernate缓存之初探</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4r6608.html">css3面试的时候需要记忆的东西</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx14mj9.html">LINUX调优</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wkzj3q.html">IOS内存管理「2」- 点语法的内存管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vpv648.html">Python GUI编程实践</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm5pg79.html">NodeJS - Express 3&period;0下ejs模板使用 partial展现 片段视图</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1vn0j9.html">Sql例子Sp&lowbar;ExecuteSql 带参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1zpog8.html">认识&amp;lt&semi;hr&amp;gt&semi;标签，添加水平横线</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1v2kj9.html">记一次lnmp环境下无法执行php文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/950pgd68.html">yii2&period;0使用ActionForm创建表单</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljkve69.html">JAVA Semaphore详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jlkzx8.html">android动画介绍之 自定义Animation动画实现qq抖一抖效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/960j6239.html">maven管理jar，pom&period;xml导入spring依赖</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/90mrj038.html">java-list-remove&lpar;&rpar;用法浅析  解决java  list remove&lpar;&rpar;  数据不对的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oj15lpq.html">ExtJS4 便捷三层开发模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv120yoq.html">android rawquery和query对照</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me2w52q.html">Java多线程之进程和线程</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rg57wr8.html">JS获取字符串实际长度</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me2kxoq.html">UVA Graph Coloring</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkd4rj8.html">wcf的binding和host</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpj4m79.html">windows服务安装启动报错误1053&colon;服务没有及时响应启动或控制请求</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljl2p69.html">变易算法 - STL算法</a>
			</li>
						<li><a href="https://www.batexi.com/a/96p02xv8.html">&lbrack;Usaco2008 Open&rsqb;Roads Around The Farm分岔路口&lbrack;水题&rsqb;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
